<template>
  <el-row
    id="tour-times-component"
    type="flex"
    justify="space-between"
    :gutter="50"
    style="flex-wrap: wrap"
  >
    <el-col :md="24" :lg="12" style="margin-bottom: 1%">
      <el-card style="overflow-x: auto">
        <div slot="header" class="card-header-title">Будние дни</div>
        <h5>Часовые интервалы</h5>
        <table>
          <tbody>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdayFullTimes.slice(
                  0,
                  workdayFullTimes.length - 18
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdayFullTimes.slice(
                  6,
                  workdayFullTimes.length - 12
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdayFullTimes.slice(
                  12,
                  workdayFullTimes.length - 6
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdayFullTimes.slice(
                  18,
                  workdayFullTimes.length
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
          </tbody>
        </table>
        <h5>Первые получасовые интервалы</h5>
        <table>
          <tbody>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdayFirstHalfTimes.slice(
                  0,
                  workdayFirstHalfTimes.length - 18
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdayFirstHalfTimes.slice(
                  6,
                  workdayFirstHalfTimes.length - 12
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdayFirstHalfTimes.slice(
                  12,
                  workdayFirstHalfTimes.length - 6
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdayFirstHalfTimes.slice(
                  18,
                  workdayFirstHalfTimes.length
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
          </tbody>
        </table>
        <h5>Вторые получасовые интервалы</h5>
        <table>
          <tbody>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdaySecondHalfTimes.slice(
                  0,
                  workdaySecondHalfTimes.length - 18
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdaySecondHalfTimes.slice(
                  6,
                  workdaySecondHalfTimes.length - 12
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdaySecondHalfTimes.slice(
                  12,
                  workdaySecondHalfTimes.length - 6
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in workdaySecondHalfTimes.slice(
                  18,
                  workdaySecondHalfTimes.length
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
          </tbody>
        </table>
      </el-card>
    </el-col>
    <el-col :xl="12" :lg="12" :md="24" style="margin-bottom: 1%">
      <el-card style="overflow-x: auto">
        <div slot="header" class="card-header-title">
          Выходные и праздничные дни
        </div>
        <h5>Часовые интервалы</h5>
        <table>
          <tbody>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendFullTimes.slice(
                  0,
                  weekendFullTimes.length - 18
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendFullTimes.slice(
                  6,
                  weekendFullTimes.length - 12
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendFullTimes.slice(
                  12,
                  weekendFullTimes.length - 6
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendFullTimes.slice(
                  18,
                  weekendFullTimes.length
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
          </tbody>
        </table>
        <h5>Первые получасовые интервалы</h5>
        <table>
          <tbody>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendFirstHalfTimes.slice(
                  0,
                  weekendFirstHalfTimes.length - 18
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendFirstHalfTimes.slice(
                  6,
                  weekendFirstHalfTimes.length - 12
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendFirstHalfTimes.slice(
                  12,
                  weekendFirstHalfTimes.length - 6
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendFirstHalfTimes.slice(
                  18,
                  weekendFirstHalfTimes.length
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
          </tbody>
        </table>
        <h5>Вторые получасовые интервалы</h5>
        <table>
          <tbody>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendSecondHalfTimes.slice(
                  0,
                  weekendSecondHalfTimes.length - 18
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendSecondHalfTimes.slice(
                  6,
                  weekendSecondHalfTimes.length - 12
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendSecondHalfTimes.slice(
                  12,
                  weekendSecondHalfTimes.length - 6
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
            <tr>
              <td
                @click="toggleTime(time)"
                :class="isTimeSelected(time) ? 'selected' : ''"
                :key="time.timeFrom.getTime()"
                v-for="time in weekendSecondHalfTimes.slice(
                  18,
                  weekendSecondHalfTimes.length
                )"
              >
                {{ getStringifyTimePeriod(time) }}
              </td>
            </tr>
          </tbody>
        </table>
      </el-card>
    </el-col>
  </el-row>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import ComponentMixin from "@/components/common/ComponentMixin";
import { MediaPlanParametersTime } from "@/interfaces/parameters/MediaPlanParametersTime";
import { MediaPlanParameters } from "@/interfaces/parameters/MediaPlanParameters";

/**
 * @class Компонент временных интервалов представления параметров автоматического размещения медиаплана.
 *
 * @property {MediaPlanParameters}       parameters             парметры автоматического размещения медиаплана.
 * @property {MediaPlanParametersTime[]} workdayFullTimes       коллекция полных часовых интервалов в будние дни.
 * @property {MediaPlanParametersTime[]} workdayFirstHalfTimes  коллекция первых получасовых интервалов в будние дни.
 * @property {MediaPlanParametersTime[]} workdaySecondHalfTimes коллекция вторых получасовых интервалов в будние дни.
 * @property {MediaPlanParametersTime[]} weekendFullTimes       коллекция полных часовых интервалов в выходные дни.
 * @property {MediaPlanParametersTime[]} weekendFirstHalfTimes  коллекция первых получасовых интервалов в выходные дни.
 * @property {MediaPlanParametersTime[]} weekendSecondHalfTimes коллекция вторых получасовых интервалов в выходные дни.
 */
@Component
export default class NewTimesComponent extends Mixins(ComponentMixin) {
  private parameters: MediaPlanParameters | null = null;
  readonly workdayFullTimes: MediaPlanParametersTime[] = [];
  readonly workdayFirstHalfTimes: MediaPlanParametersTime[] = [];
  readonly workdaySecondHalfTimes: MediaPlanParametersTime[] = [];
  readonly weekendFullTimes: MediaPlanParametersTime[] = [];
  readonly weekendFirstHalfTimes: MediaPlanParametersTime[] = [];
  readonly weekendSecondHalfTimes: MediaPlanParametersTime[] = [];

  /**
   * Метод вызывается после создания компонента.
   */
  protected created(): void {
    this.createFullTimes();
    this.createFirstHalfTimes();
    this.createSecondHalfTimes();
    // Подписываемся на событие получения параметров автоматической расстановки медиаплана
    this.subscribe(
      "media-plan-parameters-response",
      this.onMediaPlanParametersResponse
    );
  }

  /**
   * Метод создания полных часовых интервалов.
   */
  private createFullTimes(): void {
    for (let i = 0; i < 24; i++) {
      // Время начала интервала
      const timeFrom = new Date();
      // Время окончания интервала
      const timeBefore = new Date();

      // Устанавливаем время
      timeFrom.setHours(i, 0, 0, 0);
      timeBefore.setHours(i + 1, 0, 0, 0);

      // Создаём объект интервала и добавляем в список интервалов в будние дни
      this.workdayFullTimes.push(
        new MediaPlanParametersTime({
          id: 0,
          timeFrom: timeFrom,
          timeBefore: timeBefore,
          isWeekend: false,
        })
      );
      // Создаём объект интервала и добавляем в список интервалов в выходные дни
      this.weekendFullTimes.push(
        new MediaPlanParametersTime({
          id: 0,
          timeFrom: timeFrom,
          timeBefore: timeBefore,
          isWeekend: true,
        })
      );
    }
  }

  /**
   * Метод создания первых получасовых интервалов.
   */
  private createFirstHalfTimes(): void {
    for (let i = 0; i < 24; i++) {
      // Время начала интервала
      const timeFrom = new Date();
      // Время окончания интервала
      const timeBefore = new Date();

      // Устанавливаем время
      timeFrom.setHours(i, 0, 0, 0);
      timeBefore.setHours(i, 30, 0, 0);

      // Создаём объект интервала и добавляем в коллекцию первых получасовых интервалов в будние дни
      this.workdayFirstHalfTimes.push(
        new MediaPlanParametersTime({
          id: 0,
          timeFrom: timeFrom,
          timeBefore: timeBefore,
          isWeekend: false,
        })
      );
      // Создаём объект интервала и добавляем в коллекция первых получасовых интервалов в выходные дни
      this.weekendFirstHalfTimes.push(
        new MediaPlanParametersTime({
          id: 0,
          timeFrom: timeFrom,
          timeBefore: timeBefore,
          isWeekend: true,
        })
      );
    }
  }

  /**
   * Метод создания вторых получасовых интервалов.
   */
  private createSecondHalfTimes(): void {
    for (let i = 0; i < 24; i++) {
      // Время начала интервала
      const timeFrom = new Date();
      // Время окончания интервала
      const timeBefore = new Date();

      // Устанавливаем время
      timeFrom.setHours(i, 30, 0, 0);
      timeBefore.setHours(i + 1, 0, 0, 0);

      // Создаём объект интервала и добавляем в коллекцию вторых получасовых интервалов в будние дни
      this.workdaySecondHalfTimes.push(
        new MediaPlanParametersTime({
          id: 0,
          timeFrom: timeFrom,
          timeBefore: timeBefore,
          isWeekend: false,
        })
      );
      // Создаём объект интервала и добавляем в коллекция вторых получасовых интервалов в выходные дни
      this.weekendSecondHalfTimes.push(
        new MediaPlanParametersTime({
          id: 0,
          timeFrom: timeFrom,
          timeBefore: timeBefore,
          isWeekend: true,
        })
      );
    }
  }

  /**
   * Метод конвертации временного интервала в строковое представление.
   *
   * @param {MediaPlanParametersTime} time  временной интервал.
   * @return {string}                       строковое представление временного интервал.
   */
  private getStringifyTimePeriod(time: MediaPlanParametersTime): string {
    // Переводим объект времени начала периода в строку
    const timeFrom = time.timeFrom.toLocaleString("default", {
      hour: "numeric",
      minute: "numeric",
    });
    // Переводим объект времени окончания периода в строку
    const timeBefore = time.timeBefore.toLocaleTimeString("default", {
      hour: "numeric",
      minute: "numeric",
    });
    return `${timeFrom} - ${timeBefore}`;
  }

  /**
   * Метод срабатывает после получения параметров автоматического размещения медиаплана.
   *
   * @param {MediaPlanParameters} parameters параметры автоматического размещения медиаплана.
   */
  private onMediaPlanParametersResponse(parameters: MediaPlanParameters): void {
    this.parameters = parameters;
  }

  /**
   * Метод выбора\отмены выбора временного интервала.
   *
   * @param {MediaPlanParametersTime} time временной интервал, по которому кликнул пользователь.
   */
  private toggleTime(time: MediaPlanParametersTime): void {
    // Индекс найденного временного периода
    const foundTimeIndex = this.parameters?.times.findIndex((value) =>
      time.equals(value)
    );
    // Если индекс не найден - добавляем временной период в список
    if (foundTimeIndex === undefined || foundTimeIndex === -1) {
      this.parameters?.times.push(time);
    } else {
      this.parameters?.times.splice(foundTimeIndex, 1);
    }
  }

  /**
   * Метод проверки "выбран ли временной интервал".
   *
   * @param {MediaPlanParametersTime} time временной интервал.
   *
   * @return {boolean} признак "временной интервал выбран".
   */
  private isTimeSelected(time: MediaPlanParametersTime): boolean {
    const indexOf = this.parameters?.times.findIndex((value) =>
      time.equals(value)
    );
    return !(indexOf === undefined || indexOf === -1);
  }
}
</script>

<style lang="scss" scoped>
table {
  width: 100%;
  border: 1px solid gray;
  border-radius: 2px;

  td {
    cursor: pointer;
    min-width: 100px;
    text-align: center;
    user-select: none;
    background-color: white;
    padding: 1px;

    &:hover {
      padding: 0;
      border: 1px solid gray;
      border-radius: 2px;
    }

    &.selected {
      padding: 0;
      border: 1px solid gray;
      border-radius: 2px;
      background-color: #c0cce0;
    }
  }
}
</style>
